// flirc - a smallweigth FLTK irc client
// Copyright (C) 2001 Georg Lukas <georg@boerde.de>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// $Id: Fl_Irc_Output.H,v 1.3 2001/07/17 22:53:41 ge0rg Exp $

#ifndef Fl_Irc_Output_H
#define Fl_Irc_Output_H

#include <FL/Fl.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Scrollbar.H>

#ifndef Fl_Widget_H
#include <FL/Fl_Widget.H>
#endif

class Fl_Irc_Output : public Fl_Widget {

	char **linebuf_;
	Fl_Color *linecol_;
	Fl_Scrollbar *sb_;
	int sb_size;
	int linebufsize_;
	int linecount_;

	uchar textfont_;
	uchar textsize_;

protected:
	FL_EXPORT void draw();
	int draw_line_rec(int x,int top_y,int w,int y,int d,Fl_Color col,char *line);

public:
	FL_EXPORT Fl_Irc_Output(int x,int y,int w,int h,const char *l = 0);

	Fl_Font textfont() const {return (Fl_Font)textfont_;}
	void textfont(Fl_Font s) {textfont_ = s;}
	uchar textsize() const {return textsize_;}
	void textsize(int s) {textsize_ = s;}
	void clear();
	void scrollbar(Fl_Scrollbar *sb) { sb_ = sb; }

	void add_line(char *line, Fl_Color col = FL_BLACK);
};

#endif // Fl_Irc_Output_H
