// flirc - a smallweigth FLTK irc client
// Copyright (C) 2001 Georg Lukas <georg@boerde.de>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// $Id: globals.h,v 1.5 2001/07/17 22:53:41 ge0rg Exp $

#ifndef globals_h
#define globals_h

#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>

#include <FL/Fl.H>
#include <FL/fl_ask.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Multiline_Output.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Scrollbar.H>

#define TITLE "flirc 0.09f"
#define TITLE_FULL TITLE " for Agenda VR3 by Ge0rG@boerde.de"

#define IRC_PORT 6667

#define CMD_CHAR '/'
#define NUM_STR "*** "
#define COL_ERR FL_RED
#define COL_STAT (Fl_Color)8
#define COL_MSG(x) (x==0)?FL_BLACK:fl_gray_ramp(2)

#define MENU_FONT FL_HELVETICA
#define MENU_FONTSIZE 10
#define IRC_FONT FL_HELVETICA
#define IRC_FONTSIZE 9

#ifndef SOCK_STREAM
#define SOCK_STREAM 2
#endif

extern void clear();
extern void println(Fl_Color col, char *fmt, ...);
extern void flirc_quit(void);
extern void irc_disc(const char *quitmsg);

#endif // globals_h
