// flirc - a smallweigth FLTK irc client
// Copyright (C) 2001 Georg Lukas <georg@boerde.de>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// $Id: mystr.cxx,v 1.2 2001/07/17 22:53:41 ge0rg Exp $

#include <stdlib.h>
#include <string.h>

char *strnew(int length) {
	char *s = (char*)malloc(length+1);
	if (s != NULL) s[0] = '\0';
	return s;
}

char *strnew(const char *src, int length) {
	char *s = (char*)malloc(length+1);
	if (s != NULL) {
		strncpy(s, src, length);
		s[length] = '\0';
	}
	return s;
}

char *strnew(const char *src) {
	return strnew(src, strlen(src));
}




char *strrealloc(const char *old, int newlen) {
	char *s = (char*)realloc((void*)old, newlen+1);
	if (s != NULL) s[0] = '\0';
	return s;
}
char *strrealloc(const char *old, const char *newval, int newlen) {
	char *s = (char*)realloc((void*)old, newlen+1);
	if (s != NULL) {
		strncpy(s, newval, newlen);
		s[newlen] = '\0';
	}
	return s;
}
char *strrealloc(const char *old, const char *newval) {
	return strrealloc(old, newval, strlen(newval));
}




char *irctoken(char **input, bool *ctcp) {
	char *ret;
	char *pos;
	if ((input == NULL) || (*input == NULL)) return NULL;

	//printf("%s\n", *input);
	if (*input[0] == ':') {
		// letzter Parameter
		if (!*ctcp && ((*input+1)[0] == '\001')) {
			// CTCP event
			*ctcp = true;
			*input += 2;
			pos = strchr(*input, '\001');
			if (pos != NULL) { *pos = '\000'; }
			return irctoken(input, ctcp);
		}
		ret = strnew(*input+1);
		pos = NULL;
	} else {
		// Token-Ende suchen
		pos = strchr(*input, ' ');
		if (pos != NULL) {
			// Token-Ende gefunden, Token wird zurckgeliefert, input aufs
			// nchste angesetzt
			ret = strnew(*input, pos-*input);
			while (*pos == ' ') pos++;
		} else
			ret = strnew(*input);
	}
	*input = pos;
	return ret;
}

